package yukihane.inqubus.model;

import java.io.File;

/**
 *
 * @author yuki
 */
class Location {

    private final String location;

    public Location(String location) {
        if (location == null) {
            throw new IllegalArgumentException();
        }
        this.location = location;
    }

    Location(File f) {
        this.location = f.getPath();
    }

    @Override
    public String toString() {
        return location;
    }

    @Override
    public int hashCode() {
        return location.hashCode();

    }

    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Location other = (Location) obj;
        if ((this.location == null) ? (other.location != null) : !this.location.equals(other.location)) {
            return false;
        }
        return true;
    }
}
